function [color_map] = my_colormap(type, median_range)

if nargin < 2
    median_range = [0, 0.4, 0.6, 1].';
end

median_range = (median_range - min(median_range)) / range(median_range);

switch type
    case 1 % red green
        thecolor = [0,0.447000000000000,0.741000000000000;0.850000000000000,0.325000000000000,0.0980000000000000;0.929000000000000,0.694000000000000,0.125000000000000;0.494000000000000,0.184000000000000,0.556000000000000;0.466000000000000,0.674000000000000,0.188000000000000;0.301000000000000,0.745000000000000,0.933000000000000;0.635000000000000,0.0780000000000000,0.184000000000000];
        the_one = thecolor(2,:);
        the_zero = thecolor(5,:);
        the_mid = [1,1,1];
        the_colorlist = [the_zero; the_mid; the_mid; the_one];
        the_range = (0:0.005:1).';
        
        color_map = zeros(length(the_range), 3);
        for i_color = 1:3
            color_map(:, i_color) = interp1(median_range, the_colorlist(:, i_color), the_range);
        end
    case 2 % red blue
        thecolor = [0,0.447000000000000,0.741000000000000;0.850000000000000,0.325000000000000,0.0980000000000000;0.929000000000000,0.694000000000000,0.125000000000000;0.494000000000000,0.184000000000000,0.556000000000000;0.466000000000000,0.674000000000000,0.188000000000000;0.301000000000000,0.745000000000000,0.933000000000000;0.635000000000000,0.0780000000000000,0.184000000000000];
        the_one = thecolor(2,:);
        the_zero = thecolor(6,:);
        the_mid = [1,1,1];
        the_colorlist = [the_zero; the_mid; the_mid; the_one];
        the_range = (0:0.005:1).';
        
        color_map = zeros(length(the_range), 3);
        for i_color = 1:3
            color_map(:, i_color) = interp1(median_range, the_colorlist(:, i_color), the_range);
        end
    case 'summer'
        temp_map2 = [0,0.500000000000000,0.400000000000000;0.00392156862745098,0.501960784313726,0.400000000000000;0.00784313725490196,0.503921568627451,0.400000000000000;0.0117647058823529,0.505882352941176,0.400000000000000;0.0156862745098039,0.507843137254902,0.400000000000000;0.0196078431372549,0.509803921568627,0.400000000000000;0.0235294117647059,0.511764705882353,0.400000000000000;0.0274509803921569,0.513725490196078,0.400000000000000;0.0313725490196078,0.515686274509804,0.400000000000000;0.0352941176470588,0.517647058823530,0.400000000000000;0.0392156862745098,0.519607843137255,0.400000000000000;0.0431372549019608,0.521568627450980,0.400000000000000;0.0470588235294118,0.523529411764706,0.400000000000000;0.0509803921568627,0.525490196078431,0.400000000000000;0.0549019607843137,0.527450980392157,0.400000000000000;0.0588235294117647,0.529411764705882,0.400000000000000;0.0627450980392157,0.531372549019608,0.400000000000000;0.0666666666666667,0.533333333333333,0.400000000000000;0.0705882352941177,0.535294117647059,0.400000000000000;0.0745098039215686,0.537254901960784,0.400000000000000;0.0784313725490196,0.539215686274510,0.400000000000000;0.0823529411764706,0.541176470588235,0.400000000000000;0.0862745098039216,0.543137254901961,0.400000000000000;0.0901960784313726,0.545098039215686,0.400000000000000;0.0941176470588235,0.547058823529412,0.400000000000000;0.0980392156862745,0.549019607843137,0.400000000000000;0.101960784313725,0.550980392156863,0.400000000000000;0.105882352941176,0.552941176470588,0.400000000000000;0.109803921568627,0.554901960784314,0.400000000000000;0.113725490196078,0.556862745098039,0.400000000000000;0.117647058823529,0.558823529411765,0.400000000000000;0.121568627450980,0.560784313725490,0.400000000000000;0.125490196078431,0.562745098039216,0.400000000000000;0.129411764705882,0.564705882352941,0.400000000000000;0.133333333333333,0.566666666666667,0.400000000000000;0.137254901960784,0.568627450980392,0.400000000000000;0.141176470588235,0.570588235294118,0.400000000000000;0.145098039215686,0.572549019607843,0.400000000000000;0.149019607843137,0.574509803921569,0.400000000000000;0.152941176470588,0.576470588235294,0.400000000000000;0.156862745098039,0.578431372549020,0.400000000000000;0.160784313725490,0.580392156862745,0.400000000000000;0.164705882352941,0.582352941176471,0.400000000000000;0.168627450980392,0.584313725490196,0.400000000000000;0.172549019607843,0.586274509803922,0.400000000000000;0.176470588235294,0.588235294117647,0.400000000000000;0.180392156862745,0.590196078431373,0.400000000000000;0.184313725490196,0.592156862745098,0.400000000000000;0.188235294117647,0.594117647058824,0.400000000000000;0.192156862745098,0.596078431372549,0.400000000000000;0.196078431372549,0.598039215686275,0.400000000000000;0.200000000000000,0.600000000000000,0.400000000000000;0.203921568627451,0.601960784313726,0.400000000000000;0.207843137254902,0.603921568627451,0.400000000000000;0.211764705882353,0.605882352941176,0.400000000000000;0.215686274509804,0.607843137254902,0.400000000000000;0.219607843137255,0.609803921568628,0.400000000000000;0.223529411764706,0.611764705882353,0.400000000000000;0.227450980392157,0.613725490196079,0.400000000000000;0.231372549019608,0.615686274509804,0.400000000000000;0.235294117647059,0.617647058823529,0.400000000000000;0.239215686274510,0.619607843137255,0.400000000000000;0.243137254901961,0.621568627450980,0.400000000000000;0.247058823529412,0.623529411764706,0.400000000000000;0.250980392156863,0.625490196078431,0.400000000000000;0.254901960784314,0.627450980392157,0.400000000000000;0.258823529411765,0.629411764705882,0.400000000000000;0.262745098039216,0.631372549019608,0.400000000000000;0.266666666666667,0.633333333333333,0.400000000000000;0.270588235294118,0.635294117647059,0.400000000000000;0.274509803921569,0.637254901960784,0.400000000000000;0.278431372549020,0.639215686274510,0.400000000000000;0.282352941176471,0.641176470588235,0.400000000000000;0.286274509803922,0.643137254901961,0.400000000000000;0.290196078431373,0.645098039215686,0.400000000000000;0.294117647058824,0.647058823529412,0.400000000000000;0.298039215686275,0.649019607843137,0.400000000000000;0.301960784313725,0.650980392156863,0.400000000000000;0.305882352941177,0.652941176470588,0.400000000000000;0.309803921568627,0.654901960784314,0.400000000000000;0.313725490196078,0.656862745098039,0.400000000000000;0.317647058823529,0.658823529411765,0.400000000000000;0.321568627450980,0.660784313725490,0.400000000000000;0.325490196078431,0.662745098039216,0.400000000000000;0.329411764705882,0.664705882352941,0.400000000000000;0.333333333333333,0.666666666666667,0.400000000000000;0.337254901960784,0.668627450980392,0.400000000000000;0.341176470588235,0.670588235294118,0.400000000000000;0.345098039215686,0.672549019607843,0.400000000000000;0.349019607843137,0.674509803921569,0.400000000000000;0.352941176470588,0.676470588235294,0.400000000000000;0.356862745098039,0.678431372549020,0.400000000000000;0.360784313725490,0.680392156862745,0.400000000000000;0.364705882352941,0.682352941176471,0.400000000000000;0.368627450980392,0.684313725490196,0.400000000000000;0.372549019607843,0.686274509803922,0.400000000000000;0.376470588235294,0.688235294117647,0.400000000000000;0.380392156862745,0.690196078431373,0.400000000000000;0.384313725490196,0.692156862745098,0.400000000000000;0.388235294117647,0.694117647058824,0.400000000000000;0.392156862745098,0.696078431372549,0.400000000000000;0.396078431372549,0.698039215686275,0.400000000000000;0.400000000000000,0.700000000000000,0.400000000000000;0.403921568627451,0.701960784313725,0.400000000000000;0.407843137254902,0.703921568627451,0.400000000000000;0.411764705882353,0.705882352941176,0.400000000000000;0.415686274509804,0.707843137254902,0.400000000000000;0.419607843137255,0.709803921568628,0.400000000000000;0.423529411764706,0.711764705882353,0.400000000000000;0.427450980392157,0.713725490196078,0.400000000000000;0.431372549019608,0.715686274509804,0.400000000000000;0.435294117647059,0.717647058823529,0.400000000000000;0.439215686274510,0.719607843137255,0.400000000000000;0.443137254901961,0.721568627450980,0.400000000000000;0.447058823529412,0.723529411764706,0.400000000000000;0.450980392156863,0.725490196078431,0.400000000000000;0.454901960784314,0.727450980392157,0.400000000000000;0.458823529411765,0.729411764705882,0.400000000000000;0.462745098039216,0.731372549019608,0.400000000000000;0.466666666666667,0.733333333333333,0.400000000000000;0.470588235294118,0.735294117647059,0.400000000000000;0.474509803921569,0.737254901960784,0.400000000000000;0.478431372549020,0.739215686274510,0.400000000000000;0.482352941176471,0.741176470588235,0.400000000000000;0.486274509803922,0.743137254901961,0.400000000000000;0.490196078431373,0.745098039215686,0.400000000000000;0.494117647058824,0.747058823529412,0.400000000000000;0.498039215686275,0.749019607843137,0.400000000000000;0.501960784313726,0.750980392156863,0.400000000000000;0.505882352941176,0.752941176470588,0.400000000000000;0.509803921568627,0.754901960784314,0.400000000000000;0.513725490196078,0.756862745098039,0.400000000000000;0.517647058823530,0.758823529411765,0.400000000000000;0.521568627450980,0.760784313725490,0.400000000000000;0.525490196078431,0.762745098039216,0.400000000000000;0.529411764705882,0.764705882352941,0.400000000000000;0.533333333333333,0.766666666666667,0.400000000000000;0.537254901960784,0.768627450980392,0.400000000000000;0.541176470588235,0.770588235294118,0.400000000000000;0.545098039215686,0.772549019607843,0.400000000000000;0.549019607843137,0.774509803921569,0.400000000000000;0.552941176470588,0.776470588235294,0.400000000000000;0.556862745098039,0.778431372549020,0.400000000000000;0.560784313725490,0.780392156862745,0.400000000000000;0.564705882352941,0.782352941176471,0.400000000000000;0.568627450980392,0.784313725490196,0.400000000000000;0.572549019607843,0.786274509803922,0.400000000000000;0.576470588235294,0.788235294117647,0.400000000000000;0.580392156862745,0.790196078431373,0.400000000000000;0.584313725490196,0.792156862745098,0.400000000000000;0.588235294117647,0.794117647058824,0.400000000000000;0.592156862745098,0.796078431372549,0.400000000000000;0.596078431372549,0.798039215686275,0.400000000000000;0.600000000000000,0.800000000000000,0.400000000000000;0.603921568627451,0.801960784313726,0.400000000000000;0.607843137254902,0.803921568627451,0.400000000000000;0.611764705882353,0.805882352941177,0.400000000000000;0.615686274509804,0.807843137254902,0.400000000000000;0.619607843137255,0.809803921568628,0.400000000000000;0.623529411764706,0.811764705882353,0.400000000000000;0.627450980392157,0.813725490196078,0.400000000000000;0.631372549019608,0.815686274509804,0.400000000000000;0.635294117647059,0.817647058823529,0.400000000000000;0.639215686274510,0.819607843137255,0.400000000000000;0.643137254901961,0.821568627450980,0.400000000000000;0.647058823529412,0.823529411764706,0.400000000000000;0.650980392156863,0.825490196078431,0.400000000000000;0.654901960784314,0.827450980392157,0.400000000000000;0.658823529411765,0.829411764705882,0.400000000000000;0.662745098039216,0.831372549019608,0.400000000000000;0.666666666666667,0.833333333333333,0.400000000000000;0.670588235294118,0.835294117647059,0.400000000000000;0.674509803921569,0.837254901960784,0.400000000000000;0.678431372549020,0.839215686274510,0.400000000000000;0.682352941176471,0.841176470588235,0.400000000000000;0.686274509803922,0.843137254901961,0.400000000000000;0.690196078431373,0.845098039215686,0.400000000000000;0.694117647058824,0.847058823529412,0.400000000000000;0.698039215686275,0.849019607843137,0.400000000000000;0.701960784313725,0.850980392156863,0.400000000000000;0.705882352941177,0.852941176470588,0.400000000000000;0.709803921568628,0.854901960784314,0.400000000000000;0.713725490196078,0.856862745098039,0.400000000000000;0.717647058823529,0.858823529411765,0.400000000000000;0.721568627450980,0.860784313725490,0.400000000000000;0.725490196078431,0.862745098039216,0.400000000000000;0.729411764705882,0.864705882352941,0.400000000000000;0.733333333333333,0.866666666666667,0.400000000000000;0.737254901960784,0.868627450980392,0.400000000000000;0.741176470588235,0.870588235294118,0.400000000000000;0.745098039215686,0.872549019607843,0.400000000000000;0.749019607843137,0.874509803921569,0.400000000000000;0.752941176470588,0.876470588235294,0.400000000000000;0.756862745098039,0.878431372549020,0.400000000000000;0.760784313725490,0.880392156862745,0.400000000000000;0.764705882352941,0.882352941176471,0.400000000000000;0.768627450980392,0.884313725490196,0.400000000000000;0.772549019607843,0.886274509803922,0.400000000000000;0.776470588235294,0.888235294117647,0.400000000000000;0.780392156862745,0.890196078431373,0.400000000000000;0.784313725490196,0.892156862745098,0.400000000000000;0.788235294117647,0.894117647058824,0.400000000000000;0.792156862745098,0.896078431372549,0.400000000000000;0.796078431372549,0.898039215686274,0.400000000000000;0.800000000000000,0.900000000000000,0.400000000000000;0.803921568627451,0.901960784313726,0.400000000000000;0.807843137254902,0.903921568627451,0.400000000000000;0.811764705882353,0.905882352941177,0.400000000000000;0.815686274509804,0.907843137254902,0.400000000000000;0.819607843137255,0.909803921568627,0.400000000000000;0.823529411764706,0.911764705882353,0.400000000000000;0.827450980392157,0.913725490196078,0.400000000000000;0.831372549019608,0.915686274509804,0.400000000000000;0.835294117647059,0.917647058823530,0.400000000000000;0.839215686274510,0.919607843137255,0.400000000000000;0.843137254901961,0.921568627450980,0.400000000000000;0.847058823529412,0.923529411764706,0.400000000000000;0.850980392156863,0.925490196078431,0.400000000000000;0.854901960784314,0.927450980392157,0.400000000000000;0.858823529411765,0.929411764705882,0.400000000000000;0.862745098039216,0.931372549019608,0.400000000000000;0.866666666666667,0.933333333333333,0.400000000000000;0.870588235294118,0.935294117647059,0.400000000000000;0.874509803921569,0.937254901960784,0.400000000000000;0.878431372549020,0.939215686274510,0.400000000000000;0.882352941176471,0.941176470588235,0.400000000000000;0.886274509803922,0.943137254901961,0.400000000000000;0.890196078431373,0.945098039215686,0.400000000000000;0.894117647058824,0.947058823529412,0.400000000000000;0.898039215686275,0.949019607843137,0.400000000000000;0.901960784313726,0.950980392156863,0.400000000000000;0.905882352941177,0.952941176470588,0.400000000000000;0.909803921568627,0.954901960784314,0.400000000000000;0.913725490196078,0.956862745098039,0.400000000000000;0.917647058823529,0.958823529411765,0.400000000000000;0.921568627450980,0.960784313725490,0.400000000000000;0.925490196078431,0.962745098039216,0.400000000000000;0.929411764705882,0.964705882352941,0.400000000000000;0.933333333333333,0.966666666666667,0.400000000000000;0.937254901960784,0.968627450980392,0.400000000000000;0.941176470588235,0.970588235294118,0.400000000000000;0.945098039215686,0.972549019607843,0.400000000000000;0.949019607843137,0.974509803921569,0.400000000000000;0.952941176470588,0.976470588235294,0.400000000000000;0.956862745098039,0.978431372549020,0.400000000000000;0.960784313725490,0.980392156862745,0.400000000000000;0.964705882352941,0.982352941176471,0.400000000000000;0.968627450980392,0.984313725490196,0.400000000000000;0.972549019607843,0.986274509803922,0.400000000000000;0.976470588235294,0.988235294117647,0.400000000000000;0.980392156862745,0.990196078431373,0.400000000000000;0.984313725490196,0.992156862745098,0.400000000000000;0.988235294117647,0.994117647058824,0.400000000000000;0.992156862745098,0.996078431372549,0.400000000000000;0.996078431372549,0.998039215686275,0.400000000000000;1,1,0.400000000000000];
        the_color2 = temp_map2(1, :);
        the_color1 = temp_map2(1, :) * 0.6;
        the_colorlist = [the_color1; the_color2];
        the_range = (0:1/80:1).';
        temp_map1 = zeros(length(the_range), 3);
        for i_color = 1:3
            temp_map1(:, i_color) = interp1([0,1], the_colorlist(:, i_color), the_range);
        end
        color_map = [temp_map1; temp_map2];
    case 'truegray'
        color_map = [1,1,1] .* (0:0.005:0.999).';
    otherwise % gray
        color_map = [1,1,1] .* (1:-0.005:0).';
end

end